#ifndef __IUF_SHIP
#define __IUF_SHIP
/** This class represent the user spaceship.
Please note the specialized redraw function and all 
the function to start and stop the thrust and the rotation 
of the ship. 
Note also the interface between the GameSession and Ship Classes 
when a ship fires: it return a pointer to the bullet that has fired. 
This interface works well when the ship fire only a single bullet
it will probably be changed in the next releases.

*/
class Ship : public GameObj
{
 public:
	Ship();
	/// Acceleration of the ship (mt/sec^2)
	Point3f a;
	/// To know if the engine is on
	bool thrust;

	/** Ship version of the GameObj::Update().
	It modifies the velocity according to the 
	current acceleration */
	void Update(int t)
	{
		v += (t/1000.0f*a);
		GameObj::Update(t);
	}

  /// Start the Thrust of the ship accellerating it
	void ThrustOn() { 
		thrust=true;
		a=VDir();
		a*=20.0;
	}
	/// Stop the Thrust of the ship (accelleration = 0)
	void ThrustOff(){
		thrust=false;
		a.x()=a.y()=0;
	}

	/// Start the left rotation of ship 
	void StartLeft(){av=90.0;}
	/// Start the right rotation of ship 
	void StartRight(){av=-90.0;}
	/// Stop the left rotation of ship 
	void StopLeft(){av=0.0;}
	/// Stop the right rotation of ship 
	void StopRight(){av=0.0;}
	void Draw();
	
	/// Return the maximum number of bullet currently available for this ship
	int MaxBullet() {return 10;};
	
	void TerminateBullet(){ActiveBullet--;};

	/// Shoot a new bullet creating the object
	Bullet *Shoot() {
		if(ActiveBullet < MaxBullet()){
			++ActiveBullet;
			Bullet *bb =new Bullet(p,angle,v+VDir()*30);
			return bb;
		}
		else return 0;
	}
	protected:
		/// The number of active Bullet of this ship
		int ActiveBullet; 
};
#endif